#include "hmg.ch"

*----------------------------------------*
Function Main()
*----------------------------------------*

  PUBLIC nDado 
  PUBLIC aFicha := { " ⬤ ", " ⬤ ", " ⬤ ", " ⬤ "}  
  PUBLIC cName := ''
  PUBLIC nCursRow := 0
  PUBLIC nCursCol := 0

*----------------------------------------------------------*

  IF !IsWindowDefined("Form_1")    

   DEFINE WINDOW Form_1        ;
      TITLE " Parchís-Game"    ;
      WIDTH 800                ;
      HEIGHT 600               ;
      ICON 'Logo'              ; 
      BACKCOLOR { 246,225,214} ; 
      MAIN NOSIZE NOMAXIMIZE   ;
      ON MOUSEDRAG MueveControl()

      ON KEY ESCAPE ACTION Form_1.Release  

        @ 012,160 LABEL Label_55 VALUE "Parchis-Game" AUTOSIZE ;
                  FONT "Arial" SIZE 23 BOLD ITALIC ;
                  FONTCOLOR BLACK TRANSPARENT
        @ 010,159 LABEL Label_66 VALUE "Parchis-Game" AUTOSIZE ;
                  FONT "Arial" SIZE 23 BOLD ITALIC ;
                  FONTCOLOR {255,255,000}  TRANSPARENT   

    @ 055,025 IMAGE Parchi PICTURE "Resource\Tablero.jpg" TRANSPARENT WIDTH 500 HEIGHT 500 STRETCH   //<---- Tablero
       SetProperty( "Form_1","Parchi", "Enabled", .F.)

    DEFINE TIMER Timer_0 INTERVAL 1000 ACTION (RELEASE MEMORY)

    @ 045,630 IMAGE Dado_0 PICTURE "Resource\Dado-0.jpg" TRANSPARENT WIDTH 050 HEIGHT 050 STRETCH  // <----- Dado Logo
    @ 045,630 IMAGE Dado_1 PICTURE "" WIDTH 050 HEIGHT 050 STRETCH                                 // <----- Dado Aleatorio

*-------------------------------------------------------- Yellow -----------------------------------------*
    @ 432,307 IMAGE Label_01 PICTURE "Resource\Fix-01.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(1) 
    @ 455,402 IMAGE Label_02 PICTURE "Resource\Fix-05.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(2) 
    @ 455,425 IMAGE Label_03 PICTURE "Resource\Fix-09.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(3) 
    @ 455,448 IMAGE Label_04 PICTURE "Resource\Fix-13.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(4) 
*-------------------------------------------------------- Bleu -------------------------------------------*
    @ 254,401 IMAGE Label_05 PICTURE "Resource\Fix-02.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(5) 
    @ 138,402 IMAGE Label_06 PICTURE "Resource\Fix-06.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(6) 
    @ 138,425 IMAGE Label_07 PICTURE "Resource\Fix-10.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(7) 
    @ 138,448 IMAGE Label_08 PICTURE "Resource\Fix-14.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(8) 
*-------------------------------------------------------- Red --------------------------------------------*
    @ 160,224 IMAGE Label_09 PICTURE "Resource\Fix-03.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(9) 
    @ 138,084 IMAGE Label_10 PICTURE "Resource\Fix-07.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(10) 
    @ 138,107 IMAGE Label_11 PICTURE "Resource\Fix-11.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(11) 
    @ 138,130 IMAGE Label_12 PICTURE "Resource\Fix-15.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(12) 
*------------------------------------------------------- Green --------------------------------------------*
    @ 339,128 IMAGE Label_13 PICTURE "Resource\Fix-04.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(13) 
    @ 455,084 IMAGE Label_14 PICTURE "Resource\Fix-08.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(14) 
    @ 455,107 IMAGE Label_15 PICTURE "Resource\Fix-12.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(15) 
    @ 455,130 IMAGE Label_16 PICTURE "Resource\Fix-16.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(16) 
*----------------------------------------------------------------------------------------------------------*

*--------------------------------------------------------- Botones -----------------------------------------------------------------------*
    @ 125, 617 LABEL Ficha_1 VALUE aFicha WIDTH 085 HEIGHT 27 BACKCOLOR { 238,113,249} FONTCOLOR YELLOW ACTION RollDice(1) CENTERALIGN 
    @ 155, 617 LABEL Ficha_2 VALUE aFicha WIDTH 085 HEIGHT 27 BACKCOLOR { 238,113,249} FONTCOLOR BLUE   ACTION RollDice(2) CENTERALIGN 
    @ 185, 617 LABEL Ficha_3 VALUE aFicha WIDTH 085 HEIGHT 27 BACKCOLOR { 238,113,249} FONTCOLOR RED    ACTION RollDice(3) CENTERALIGN 
    @ 215, 617 LABEL Ficha_4 VALUE aFicha WIDTH 085 HEIGHT 27 BACKCOLOR { 238,113,249} FONTCOLOR GREEN  ACTION RollDice(4) CENTERALIGN 
*-----------------------------------------------------------------------------------------------------------------------------------------*

           nDado = 0 
                                     
      @ 280,538 LABEL xFicha_1  VALUE "Jugador Yellow: Último Dado ! -»  " + ALLTRIM(  STRZero( nDado , 2 ) )  ;    
         WIDTH 280 HEIGHT 20 ;
         FONT "Arial" ;
         SIZE 10;
         BOLD ;
         BACKCOLOR  { 246,225,214};
         FONTCOLOR BLUE 

                                     
      @ 310,538 LABEL xFicha_2  VALUE "Jugador Blue:"+SPACE(3)+" Último Dado !  -» " + ALLTRIM(  STRZero( nDado , 2 ) )  ;  
         WIDTH 280 HEIGHT 20 ;
         FONT "Arial" ;
         SIZE 10;
         BOLD ;
         BACKCOLOR { 246,225,214};
         FONTCOLOR BLUE
                                     
      @ 340,540 LABEL xFicha_3  VALUE "Jugador Red:"+SPACE(3)+"  Último Dado !  -» " + ALLTRIM(  STRZero( nDado , 2 ) )  ;  
         WIDTH 280 HEIGHT 20 ;
         FONT "Arial" ;
         SIZE 10;
         BOLD ;
         BACKCOLOR  { 246,225,214} ;
         FONTCOLOR BLUE 
                                   
     @ 370,540 LABEL xFicha_4 VALUE "Jugador Green:"+SPACE(0)+" Último Dado !  -» " + ALLTRIM(  STRZero( nDado , 2 ) )  ;  
         WIDTH 280 HEIGHT 20 ;
         FONT "Arial" ;
         SIZE 10;
         BOLD ;
         BACKCOLOR  { 246,225,214} ;
         FONTCOLOR BLUE 

    DEFINE BUTTON BtnClea
        ROW    405
        COL    607
        WIDTH  105
        HEIGHT 060
        ACTION  RDeleter()
        CAPTION "New Game"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "New Game"
        PICTURE 'Resource\Cleaner.bmp' 
        PICTALIGNMENT TOP
    END BUTTON


    DEFINE BUTTON BtnExit
        ROW    480
        COL    607
        WIDTH  105
        HEIGHT 060
        ACTION  Form_1.Release
        CAPTION "Exit"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Exit"
        PICTURE 'Resource\Exit.bmp' 
        PICTALIGNMENT TOP
    END BUTTON


   END WINDOW
    
     HMG_ChangeWindowStyle( GetControlHandle( "Parchi", "Form_1" ), LVS_REPORT, NIL, .T. )

     HMG_ChangeWindowStyle( GetControlHandle( "Ficha_1", "Form_1" ), LVS_REPORT, NIL, .T. )
     HMG_ChangeWindowStyle( GetControlHandle( "Ficha_2", "Form_1" ), LVS_REPORT, NIL, .T. )
     HMG_ChangeWindowStyle( GetControlHandle( "Ficha_3", "Form_1" ), LVS_REPORT, NIL, .T. )
     HMG_ChangeWindowStyle( GetControlHandle( "Ficha_4", "Form_1" ), LVS_REPORT, NIL, .T. )

     SETWINDOWCURSOR( Form_1.Ficha_1.Handle, "Resource\SmoothHand.cur" )
     SETWINDOWCURSOR( Form_1.BtnExit.Handle, "Resource\SmoothHand.cur" )


   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

   ELSE

        DoMethod ("Form_1","Restore")
     
   ENDIF

RETURN Nil


*---------------------------------------------*
Function RDeleter()
*---------------------------------------------*
  DECLARE WINDOW Form_1  
  
  SetProperty("Form_1", "Parchi", "Visible",.F.)

  DoMethod ( "Form_1","Label_01", "Release" )
  DoMethod ( "Form_1","Label_02", "Release" )
  DoMethod ( "Form_1","Label_03", "Release" )
  DoMethod ( "Form_1","Label_04", "Release" )
  DoMethod ( "Form_1","Label_05", "Release" )
  DoMethod ( "Form_1","Label_06", "Release" )
  DoMethod ( "Form_1","Label_07", "Release" )
  DoMethod ( "Form_1","Label_08", "Release" )
  DoMethod ( "Form_1","Label_09", "Release" )
  DoMethod ( "Form_1","Label_10", "Release" )
  DoMethod ( "Form_1","Label_11", "Release" )
  DoMethod ( "Form_1","Label_12", "Release" )
  DoMethod ( "Form_1","Label_13", "Release" )
  DoMethod ( "Form_1","Label_14", "Release" )
  DoMethod ( "Form_1","Label_15", "Release" )
  DoMethod ( "Form_1","Label_16", "Release" )

*-------------------------------------------------------------- Yellow ----------------------------------------------*
    @ 432,307 IMAGE Label_01 PARENT Form_1 PICTURE "Resource\Fix-01.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(1) 
    @ 455,402 IMAGE Label_02 PARENT Form_1 PICTURE "Resource\Fix-05.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(2) 
    @ 455,425 IMAGE Label_03 PARENT Form_1 PICTURE "Resource\Fix-09.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(3) 
    @ 455,448 IMAGE Label_04 PARENT Form_1 PICTURE "Resource\Fix-13.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(4) 
*-------------------------------------------------------------- Bleu -------------------------------------------------*
    @ 254,401 IMAGE Label_05 PARENT Form_1 PICTURE "Resource\Fix-02.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(5) 
    @ 138,402 IMAGE Label_06 PARENT Form_1 PICTURE "Resource\Fix-06.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(6) 
    @ 138,425 IMAGE Label_07 PARENT Form_1 PICTURE "Resource\Fix-10.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(7) 
    @ 138,448 IMAGE Label_08 PARENT Form_1 PICTURE "Resource\Fix-14.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(8) 
*-------------------------------------------------------------- Red --------------------------------------------------*
    @ 160,224 IMAGE Label_09 PARENT Form_1 PICTURE "Resource\Fix-03.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(9) 
    @ 138,084 IMAGE Label_10 PARENT Form_1 PICTURE "Resource\Fix-07.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(10) 
    @ 138,107 IMAGE Label_11 PARENT Form_1 PICTURE "Resource\Fix-11.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(11) 
    @ 138,130 IMAGE Label_12 PARENT Form_1 PICTURE "Resource\Fix-15.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(12) 
*------------------------------------------------------------- Green --------------------------------------------------*
    @ 339,128 IMAGE Label_13 PARENT Form_1 PICTURE "Resource\Fix-04.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(13) 
    @ 455,084 IMAGE Label_14 PARENT Form_1 PICTURE "Resource\Fix-08.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(14) 
    @ 455,107 IMAGE Label_15 PARENT Form_1 PICTURE "Resource\Fix-12.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(15) 
    @ 455,130 IMAGE Label_16 PARENT Form_1 PICTURE "Resource\Fix-16.jpg" WIDTH 20 HEIGHT 20 STRETCH ACTION MiNombre(16) 
*----------------------------------------------------------------------------------------------------------------------*
   
    SetProperty("Form_1", "Parchi", "Visible",.T.)
    
    nDado = 0 

    Form_1.xFicha_1.Value := "Jugador Yellow: Último Dado ! -»  " + ALLTRIM( STRZero( nDado , 2 ) ) 
    Form_1.xFicha_2.Value := "Jugador Blue:" +SPACE(3) + " Último Dado !  -» "  + ALLTRIM( STRZero( nDado , 2 ) )
    Form_1.xFicha_3.Value := "Jugador Red:"  +SPACE(3) + "  Último Dado !  -» " + ALLTRIM( STRZero( nDado , 2 ) )
    Form_1.xFicha_4.Value := "Jugador Green:"+SPACE(1) + " Último Dado ! -» "   + ALLTRIM( STRZero( nDado , 2 ) ) 

Return Nil


*---------------------------------------------*
FUNCTION RollDice(nPlayer)
*---------------------------------------------*

    * Ocultar la imagen del dado inicial
    DoMethod("Form_1", "Dado_0", "Hide")

    * Generar un número aleatorio para el dado
    nDado := HB_RandomInt(1, 6)

    * Actualizar la imagen del dado con el número generado
    cImagenDado := HB_CurDrive() + ':\' + Curdir() + '\' + "Resource\Dado-" + ALLTRIM(STR(nDado)) + ".jpg"

     SetProperty("Form_1", "Dado_1", "Picture", cImagenDado)

    * Actualizar el mensaje del jugador actual con el número generado                                                     
    cMensaje := "Jugador " + IIF(nPlayer = 1, "Yellow:", IIF(nPlayer = 2, "Blue:"+SPACE(3), IIF(nPlayer = 3, "Red:"+SPACE(3), "Green:"))) + " Último Dado ! -»  " + ALLTRIM(STRZero(nDado, 2))

    SetProperty("Form_1", "xFicha_" + LTRIM(STR(nPlayer)), "Value", cMensaje)

RETURN


*---------------------------------------------*
PROCEDURE MueveControl()
*---------------------------------------------*

* https://www.hmgforum.com/viewtopic.php?p=33619&hilit=arrastrar+y+soltar#p33619
*  Courtesy of Javier Tovar  


 DECLARE WINDOW Form_1

   nCursRow := GetCursorPos()[ 1 ] - Form_1.Row  -25 
   nCursCol := GetCursorPos()[ 2 ] - Form_1.Col  -15


  IF IsWindowActive( Form_1) 
      Form_1.&(cName).Row := nCursRow
      Form_1.&(cName).Col := nCursCol 
  ELSE
       DoMethod ("Form_1","Restore")
  ENDIF

RETURN NIL

*---------------------------------------------*
PROCEDURE MiNombre(nControl)
*---------------------------------------------*
* https://www.hmgforum.com/viewtopic.php?p=33619&hilit=arrastrar+y+soltar#p33619
*  Courtesy of Javier Tovar  
        
   IF nControl = 1
      cName := "Label_01"
   ELSEIF nControl = 2
      cName := "Label_02"
   ELSEIF nControl = 3
      cName := "Label_03" 
   ELSEIF nControl = 4
      cName := "Label_04"   
   ELSEIF nControl = 5
      cName := "Label_05"   
   ELSEIF nControl = 6
      cName := "Label_06"
   ELSEIF nControl = 7
      cName := "Label_07" 
   ELSEIF nControl = 8
      cName := "Label_08"   
   ELSEIF nControl = 9
      cName := "Label_09"   
   ELSEIF nControl = 10
      cName := "Label_10"
   ELSEIF nControl = 11
      cName := "Label_11" 
   ELSEIF nControl = 12
      cName := "Label_12"   
   ELSEIF nControl = 13
      cName := "Label_13"   
   ELSEIF nControl = 14
      cName := "Label_14"
   ELSEIF nControl = 15
      cName := "Label_15" 
   ELSEIF nControl = 16
      cName := "Label_16"   
   ENDIF
RETURN NIL

*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*-.-_._-.-*




























